#include "fwinfo.h"
#include "settings.h"

/*================================================================================================*/
/* Модификация (LTR-CU-1 или LTR-CEU-1), определенная чтением ножки SET_PIN_DEV_MODEL */
static enum en_fwinfo_dev_model f_model;

static const char* const dev_name[FWINFO_DEV_MODEL__COUNT__] =
    { FWINFO_DEVICE_NAME_CU, FWINFO_DEVICE_NAME_CEU };
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void fwinfo_init(void)              /* Инициализация, чтение номера модели и серийного номера */
    {
    /* Определение типа устройства */
    LPC_PIN_CONFIG(SET_PIN_DEV_MODEL, 1, LPC_PIN_PULLUP);
    LPC_PIN_DIR_IN(SET_PIN_DEV_MODEL);
    
    /* Задержка на установление уровня, если ножка висит в воздухе и заряжается через подтяжку */
    lpc_delay_clk(CYCLES_NS_NLESS(LPC_SYSCLK, 100));

    f_model = (SET_PINVAL_DEV_MODEL_CEU == LPC_PIN_IN(SET_PIN_DEV_MODEL))
        ? FWINFO_DEV_MODEL_CEU : FWINFO_DEV_MODEL_CU;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
enum en_fwinfo_dev_model fwinfo_get_dev_model(void)
    {
    return f_model;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
const char* fwinfo_get_dev_name(void)
    {
    return dev_name[f_model];
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
